import React from "react";
import { Query, QuerySpec } from "../query";

interface Result {
  output: string;
}

interface Variables {
  y: string;
}

const exampleQuery: QuerySpec<Result, Variables> = {
  query: "query test {}",
};

const ComponentWithQueryAndVariables: React.SFC<{}> = () => {
  return (
    <Query<Result, Variables> query="test" variables={{ y: "yes" }}>
      {data => (
        <div>
          {data.state === "subscribed" ? data.value.output : "loading..."}
        </div>
      )}
    </Query>
  );
};

const instanceWithQueryAndVariables = <ComponentWithQueryAndVariables />;

const ComponentWithSpec: React.SFC<{}> = () => {
  return (
    <Query query={exampleQuery} variables={{ y: "yes" }}>
      {data => (
        <div>
          {data.state === "subscribed" ? data.value.output : "loading..."}
        </div>
      )}
    </Query>
  );
};

const instanceWithSpec = <ComponentWithSpec />;
